/******************************************************************
 * Qiang Zheng,
 * ECS Dept, Syracuse Univ. Nov. 10, 1999
 * for CIS 615 class, Spring, 2000,
 * Instructor: Geoffrey C Fox, Nancy McCracken
 * O.S.: Solaris  Environment: VPL
 * Libraries: mpilib.a
 *
 * Purpose:     A ring program that passing a token around until
 * the token returns the original place 
 * based on Example for CPS615 - Homework 3  -- Saleh Elmohamed
 ******************************************************************/

#include	<stdio.h>
#include	<mpi.h>
#define tag   0

void main (int argc, char *argv[])
{
  int myId, procNum, right, left, token, sum=0;
  MPI_Status  stat;
  MPI_Request sendReq, recvReq;

  MPI_Init(&argc, &argv);
  MPI_Comm_rank(MPI_COMM_WORLD, &myId);
  MPI_Comm_size(MPI_COMM_WORLD, &procNum);

  left=( myId-1+procNum )%procNum;
  right=( myId+1+procNum )%procNum;
  token=myId;

  do {
    MPI_Isend( &token, 1, MPI_INT, right, tag, MPI_COMM_WORLD, &sendReq );
    MPI_Irecv( &token, 1, MPI_INT, left, tag, MPI_COMM_WORLD, &recvReq );
    MPI_Wait(&sendReq, &stat);
    MPI_Wait(&recvReq, &stat);
    sum+=token;

  } while ( token!=myId );

  printf ("Processor%d:\tSum = %d\n", myId, sum);
  MPI_Finalize();
}
